<template>
  <v-row>
    <v-col>
      <head-bar :title="pageTitle" back />

      <!-- Cart restaurant -->
      <v-row>
        <v-col>
          <h2>
            <v-icon>mdi-silverware-fork-knife</v-icon>
            {{ cartRestaurant.name }}
          </h2>
        </v-col>
      </v-row>

      <v-row>
        <!-- Cart items list -->
        <v-col cols="12" sm="9">
          <cart-item-list :cart-items="cartItems" buttons></cart-item-list>
        </v-col>

        <!-- Price -->
        <v-col cols="12" sm="3">
          <price-recap :items="cartItems"></price-recap>
        </v-col>
      </v-row>

      <!-- Checkout button -->
      <v-row>
        <v-col>
          <v-btn :disabled="isEmpty" @click="clearCart"> Clear </v-btn>
          <v-btn color="primary" :disabled="isEmpty" nuxt to="/cart/checkout">
            Checkout
          </v-btn>
        </v-col>
      </v-row>
    </v-col>
  </v-row>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  data() {
    return {
      pageTitle: 'Cart',
    }
  },
  computed: {
    cartRestaurant(): any {
      return this.$store.state.cart.restaurant
    },
    cartItems(): Array<object> {
      return this.$store.state.cart.items
    },
    isEmpty(): boolean {
      return this.cartItems.length === 0
    },
  },
  methods: {
    clearCart(): void {
      this.$store.commit('cart/clear')
    },
  },
})
</script>
